﻿#!/usr/bin/python2.4
# -*- coding: UTF-8 -*-

"""
Applet Colisage pour CegidPMI
Copyright SERMO.

"""

#import cherrypy
import os,string,urllib,datetime,shutil,time
import cegidpmiapp
import base64
from decimal import Decimal

from cStringIO import StringIO

from eti9 import draw_eti9,mm
from reportlab.pdfgen import canvas

#from html_widgets import *

SQL_RAL="""
SELECT lcktnumero||'.'||lcktligne as cde,lcctcode as codeclient, clctnom as Client, lcctcodart as codeart, lcctcomart as ccart,  arcnpcecon as QuanCond,
rtrim(lcctlib01)||' '||rtrim(lcctlib02) as Lib,lccnqtecde as QteCde, lccnqteexp as QteExp, lccjdelexp as delaiexp,
(lccnqtecde-lccnqteexp) as QTERAL,(lccnqtecde-lccnqteexp)/case arcnpcecon when 0 then 1 else arcnpcecon end as ColisRAL,rtrim(article.arctartrep) as NBUCUM
FROM LCOMCLI
LEFT JOIN CLIENT on lcktsoc=clktsoc and lcctcode=clktcode
LEFT JOIN ARTICLE on lcktsoc=arktsoc and lcctcodart=arktcodart and lcctcomart=arktcomart
WHERE
LCKTSOC='100' AND LCCTTYPE='S' AND
SUBSTR(LCCTSOLACE,1,1)<>'S' AND
(lccnqtecde-lccnqteexp)>0.001
order by lccjdelexp
"""

SQL_OFART="""
SELECT lcktnumero||'.'||lcktligne ||'.'||lcktpsf as NOOF,lcctcodart as codeart, lcctcomart as ccart, lcctlib01||' '||lcctlib02 as Lib, lccjdelexp as delai
FROM LCOMCLI
WHERE
LCKTSOC='100' AND LCCTTYPE='P'
and lcctcodart='%(codeart)s' and lcctcomart='%(ccart)s'
"""

SQL_UM="""select * from proc_genum"""


SQL_COLISAGE="""
select
     COLIS.CGKTNUMERO as CDE
     , COLIS.CGKTLIGNE as LIGNE
     , COLIS.CGKTPSF as EXPE
     , COLIS.CGKNINDCOL as INDCOL
     , COLIS.CGCTIDPAL as IDPAL
     , COLIS.CGCTIDCOL as IDCOL
     , COLIS.CGCNQTECOL as QTECOL
     , COLIS.CGCTCODART as CODART
     , COLIS.CGCTCOMART as COMART
     , COLIS.CGCTNUMETI as NUMETI
     , COLIS.CGCJCRE as DATECREAT
from colis
where
  COLIS.CGCTIDPAL='%(idpal)s'
order by COLIS.CGCTIDCOL
"""


SQL_ETI9="""
select lcktnumero||'.'||lcktligne||'.'||lcktpsf as CDE,
lcctcodart as CODEART,lcctcomart as CCART,lccjdelfab as DATECREAT,
lcctrefext as REFERENCE,arcnpdsuni as PDSBRUT,
lcctrubaff as NOETI,
case when refext.RFCTLIB01 is not null and refext.RFCTLIB01<>'' then rtrim(refext.RFCTLIB01)||' '|| rtrim(refext.RFCTLIB02) ELSE rtrim(arctlib01)||' '|| rtrim(arctlib02) end as LIBART,
arcnpcecon as QTECOND,arctnofou1 as CODECLIENT,
clctnom as CLIENT,clctnofour as CODEFOURNISSEUR,arctcodcat as PT_DECHARG
from lcomcli
left join article on (arktcodart=lcctcodart and arktcomart=lcctcomart and arktsoc=lcktsoc)
left join client on (arctnofou1=clktcode and clktsoc=lcktsoc)
left join refext on (rfktcodart=lcctcodart and rfktcomart=lcctcomart and clktcode=rfktcode)
where lcktsoc='100' and lccttype='P' and lcktnumero='%(cde)s' and lcktligne='%(ligne)s' and lcktpsf='000'
"""

SQL_ETI9_PROD_RESULTANT="""
select distinct bektnumero||'.'||bektligne||'.'||bektnocomp as CDE,
bectcodcom as CODEART,bectcccomp as CCART,lccjdelfab as DATECREAT,
rfctref as REFERENCE,arcnpdsuni as PDSBRUT,
lcctrubaff as NOETI,case when refext.RFCTLIB01 is not null and refext.RFCTLIB01<>'' then rtrim(refext.RFCTLIB01)||' '|| rtrim(refext.RFCTLIB02) ELSE rtrim(arctlib01)||' '|| rtrim(arctlib02) end as LIBART,
arcnpcecon as QTECOND,arctnofou1 as CODECLIENT,
clctnom as CLIENT,clctnofour as CODEFOURNISSEUR,arctcodcat as PT_DECHARG
from besoin
left join lcomcli on (bektsoc=lcktsoc and bektnumero=lcktnumero and  bektligne=lcktligne and bektindpsf=lcktpsf)
left join article on (arktcodart=bectcodcom and bectcccomp=arktcomart and arktsoc=bektsoc)
left join client on (bectcompte=clktcode and clktsoc=lcktsoc)
left join refext on (bectcodcom=rfktcodart and bectcccomp=rfktcomart and bectcompte=rfktcode)
where bektsoc='100' and bektnumero='%(cde)s' and bektligne='%(ligne)s' and bektindpsf='000' and bectfatncp='32'
"""

SQL_ENS_PROCESS="""
select * from lcomcli where lcktsoc='100' and lcktnumero='%(cde)s' and lcktligne='%(ligne)s' and lcktpsf='000' and lcctfatn='33'
"""

SQL_CODART_CDE="""
select lcctcodart as CODEART,lcctcomart as CCART
from lcomcli
where lcktsoc='100' and lccttype='P' and lcktnumero='%(cde)s' and lcktligne='%(ligne)s' and lcktpsf='000'
"""

SQL_REFART_CDE="""
select lcctrefext as REFERENCE,lcctcomart as CCART,arcnpcecon as QTECOND
from lcomcli
left join article on (arktcodart=lcctcodart and arktcomart=lcctcomart and arktsoc=lcktsoc)
where lcktsoc='100' and lccttype='P' and lcktnumero='%(cde)s' and lcktligne='%(ligne)s' and lcktpsf='000'
"""

SQL_REFART_CDE_RESULTANT="""
select rfctref as REFERENCE,bectcccomp as CCART,arcnpcecon as QTECOND
from besoin
left join refext on (bectcodcom=rfktcodart and bectcccomp=rfktcomart and bectcompte=rfktcode)
left join article on (arktcodart=bectcodcom and bectcccomp=arktcomart and arktsoc=bektsoc)
where bektsoc='100' and bektnumero='%(cde)s' and bektligne='%(ligne)s' and bektnocomp='%(nocomp)s' and bektindpsf='000' and bectfatncp='32'
"""

SQL_ETIQUETTE_RECEPTION="""
select clctnom,lcctlib02,lcctcodemp,lcctlib01,lcctcodart,lccnqteexp,lcctunisto,lcctnumlot,lccjcre,ecctderbl,ecctutimod,lccjcre
from lrecfou
left join erecfou on(ecktnumero=lcktnumero and ecktindice=lcktpsf)
left join fournis on (clktcode=lcctcode)
where ecctderbl='%(nobl)s'
"""

# For getting the name of current running function...
import inspect
def get_my_name() :
    return inspect.stack()[1][3]


def makecsv(cur):
    """ Create a csv string from a cursor without headers"""
    def colformat(c):
        if c is None:
            return ""
        else:
            return str(c).strip()

    csv=""
    return "\r\n".join( [ ";".join( [colformat(c) for c in r]) for r in cur.fetchall()])

class BFCipher:
    def __init__(self, pword):
        self.__cipher = Blowfish.new(pword)
    def encrypt(self, file_buffer):
        ciphertext = self.__cipher.encrypt(self.__pad_file(file_buffer))
        return ciphertext
    def decrypt(self, file_buffer):
        cleartext = self.__depad_file(self.__cipher.decrypt(file_buffer))
        return cleartext
    # Blowfish cipher needs 8 byte blocks to work with
    def __pad_file(self, file_buffer):
        pad_bytes = 8 - (len(file_buffer) % 8)
        for i in range(pad_bytes - 1): file_buffer += chr(randrange(0, 256))
        # final padding byte; % by 8 to get the number of padding bytes
        bflag = randrange(6, 248); bflag -= bflag % 8 - pad_bytes
        file_buffer += chr(bflag)
        return file_buffer
    def __depad_file(self, file_buffer):
        pad_bytes = ord(file_buffer[-1]) % 8
        if not pad_bytes: pad_bytes = 8
        return file_buffer[:-pad_bytes]


class Colisage(cegidpmiapp.CegidpmiApp):
    """Application serveur http pour terminaux codes à barre
    """
    def __init__(self):
        cegidpmiapp.CegidpmiApp.__init__(self)

    def index(self):
        return self.template('Colisage CegidPMI...','''
            Rien à voir ici...
            <ul>
            <li><a href=ral>CSV du Reste à livrer</a></li>
            <li><a href=form_eti9>Etiquettes ETI9</a></li>
            </ul>
            ''')
    index.exposed=True

    def ral(self):
        """Reste à livrer sous forme CSV
        cde,codeclient, Client, codeart, ccart,  QuanCond, Lib, QteCde, QteExp, delaiexp, QTERAL,ColisRAL,NBUCUM
            Attention : le champ arcnpcecon des articles doit être <>0
        """
        cherrypy.response.headerMap["Content-Type"] = "text/csv"
        cherrypy.response.headerMap["Content-Disposition"] = "attachment; filename=%s.csv" % get_my_name()
        cherrypy.response.headerMap["Cache-Control"] = "no-store"

        return makecsv(self.select(SQL_RAL))
    ral.exposed=True


    def ofart(self,codeart,ccart):
        """Info traçabilité sur les OFs produits pour un Article sous forme CSV
            NOOF,codeart, ccart, Lib, delai
        """
        cherrypy.response.headerMap["Content-Type"] = "text/csv"
        cherrypy.response.headerMap["Content-Disposition"] = "attachment; filename=%s.csv" % get_my_name()
        cherrypy.response.headerMap["Cache-Control"] = "no-store"
        print SQL_OFART % {'codeart':codeart,'ccart':ccart}
        return makecsv(self.select(SQL_OFART % {'codeart':codeart,'ccart':ccart}))
    ofart.exposed=True

    def getnewidum(self):
        """Génère un nouvel identifiant UM"""
        cherrypy.response.headerMap["Content-Type"] = "text/plain"
        cherrypy.response.headerMap["Cache-Control"] = "no-store"
        return str(self.select(SQL_UM).fetchall()[0][0])
    getnewidum.exposed=True

    def getcodartcde(self,cde,ligne):
        """Renvoie code article et cc article d'un OF interne
        """
        cherrypy.response.headerMap["Content-Type"] = "text/plain"
        cherrypy.response.headerMap["Cache-Control"] = "no-store"
        (codart,ccart)=self.select(SQL_CODART_CDE % {'cde':cde,'ligne':ligne} ).fetchall()[0]
        return "%s;%s" % (codart.strip(),ccart.strip())
    getcodartcde.exposed=True

    def getrefartcde(self,codebarre):
        """Renvoie référence externe l'indice article et la qte conditionnement
                de l'article en fonction code barre OF
        Prends en compte les OF Process avec produits résultants multiples.
            Dans ce cas, le code barre est composé de OF.ligne.no_composant
        Pour les OF classiques, le code barre est OF.ligne
        """
        cherrypy.response.headerMap["Content-Type"] = "text/plain"
        cherrypy.response.headerMap["Cache-Control"] = "no-store"
        try:
            (cde,ligne,nocomp)=codebarre.split('.')
            # Teste avec la requête de produit résultants
            ref_ind=self.select(SQL_REFART_CDE_RESULTANT % {'cde':cde,'ligne':ligne,'nocomp':nocomp} ).fetchall()
            if ref_ind:
                (codart,ccart,qtecond)=ref_ind[0]
            # Teste avec la requête OF simple
            else:
                ref_ind=self.select(SQL_REFART_CDE % {'cde':cde,'ligne':ligne} ).fetchall()
                if ref_ind:
                    (codart,ccart,qtecond)=ref_ind[0]
                else:
                    (codart,ccart,qtecond)=('','',0.0)
        except:
            (codart,ccart,qtecond)=('','',0.0)

        if codart==None:
            codart=''
        if ccart==None:
            ccart=''
        if qtecond==None:
            qtecond=0.0
        return "%s;%s;%f" % (codart.strip(),ccart.strip(),qtecond)
    getrefartcde.exposed=True

    def colisage(self,idpal):
        """Non fonctionnel.
        Renvoie le colisage actuel associé à un n° d'UM
        """
        cherrypy.response.headerMap["Content-Type"] = "text/csv"
        cherrypy.response.headerMap["Content-Disposition"] = "attachment; filename=%s.csv" % get_my_name()
        cherrypy.response.headerMap["Cache-Control"] = "no-store"
        print SQL_COLISAGE % {'idpal':idpal}
        return makecsv(self.select(SQL_COLISAGE % {'idpal':idpal}))
    colisage.exposed=True

    def update_colisage(self,csvbase64,cde):
        """Crée un fichier CSV pour la fonction expédition rapide code barre de CegidPMI"""
        # Add some padding at the end so that it fit the multiple of 8 requirement of base64decode
        pad='=' * (8 - len(csvbase64.replace('\r\n','')) % 8)
        csvbase64=csvbase64+pad
        csv=base64.decodestring(csvbase64)
        incols=['cde','codeart','ccart','lot','uc','um','quantcond']
        inrecs=[]
        for r in csv.splitlines():
            if r:
                newrec={}
                csvrec=r.split(';')
                i=0
                for c in incols:
                    newrec[c]=csvrec[i]
                    i+=1
                inrecs.append(newrec)
        # Trier par UM, UC pour pouvoir numeroter les palettes et colis
        inrecs.sort(cmp=lambda x,y: cmp(x['um']+x['uc'], y['um']+y['uc']))
        # Verif meme cde

        # Verifier quant/article par rapport a la commande
        # Si incomplet : BL sera acompte sinon solde.

        # transformer en fichier integration CegidPMI
        if os.path.isdir('/home/exchange/'):
            if not os.path.isdir('/home/exchange/cegidpmi/expes/'):
                os.makedirs('/home/exchange/cegidpmi/expes')
            file=open('/home/exchange/cegidpmi/expes/%s.txt' % (cde),'w')
        else:
            file=open('s:/%s.txt' % (cde),'w')

        print inrecs
        #outcols="%(type)s;%(cde)%(ligne)s;%(depot)s;%(lot)s;%(nocolis)s;%(qtecolis)s;%(pdsnet)s;%(pdsnet)s;%(volume)s;%(nopalette)s;%(codeembal)s;%(libembal)s;%(datecol)s;%(um)s;%(uc)s;%(noordre)i;%(pointdest)s"
        lignecegid="X;%(nocde)s%(noligne)s;;%(lot)s;%(noordre)i;%(quantcond)s;;;;;;;;%(um)s;%(uc)s;%(noordre)i;"

        noordre=1
        for c in inrecs:
            c['noordre']=noordre
            (c['nocde'],c['noligne'])=c['cde'].split('.')
            file.write(lignecegid % c)
            file.write('\r\n')
            noordre+=1
        file.close()
        return "OK"

    update_colisage.exposed=True

    def uploadcolisage(self,csvbase64,nobl,cde='NOCDE.LIGNE'):
        """Crée un fichier CSV pour la fonction upload colisage aviexp de eCar Tenor
        Si cde est spécifié, alors un fichier d'expédition codes barres pour CegidPMI est créé"""
        #open('/home/share/%s-csvbase64.txt' % nobl,'w').write(csvbase64)

        # Add some padding at the end so that it fit the multiple of 8 requirement of base64decode
        pad='=' * (8 - len(csvbase64.replace('\r\n','')) % 8)
        csvbase64=csvbase64+pad
        csv=base64.decodestring(csvbase64)
        incols=['nobl','refart','ccart','um','uc','lot','quantcond']
        inrecs=[]
        for r in csv.splitlines():
            if r:
                newrec={}
                csvrec=r.split(';')
                i=0
                for c in incols:
                    newrec[c]=csvrec[i]
                    i+=1
                inrecs.append(newrec)

        # Trier par refart/ccart pour pouvoir numeroter les palettes et colis [issue1878]
        inrecs.sort(cmp=lambda x,y: cmp(x['refart']+x['ccart']+x['um']+x['uc'], y['refart']+y['ccart']+y['um']+y['uc']))
        # Verif meme cde

        # Verifier quant/article par rapport a la commande
        # Si incomplet : BL sera acompte sinon solde.

        # transformer en fichier integration CegidPMI
        # if os.path.isdir('/home/share/'):
        if os.path.isdir('/home/exchange/cegidpmi/aviexp/'):
        #    file=open('/home/share/%s.csv' % (nobl),'wb')
            file=open('/home/exchange/cegidpmi/aviexp/%s.csv' % (nobl),'wb')
        else:
            file=open('s:/%s.csv' % (nobl),'wb')

        #outcols="%(type)s;%(cde)%(ligne)s;%(depot)s;%(lot)s;%(nocolis)s;%(qtecolis)s;%(pdsnet)s;%(pdsnet)s;%(volume)s;%(nopalette)s;%(codeembal)s;%(libembal)s;%(datecol)s;%(um)s;%(uc)s;%(noordre)i;%(pointdest)s"
        ligneaviexp="%(nobl)s;%(refart)s;%(ccart)s;%(um)s;%(uc)s;%(lot)s"

        noordre=1
        for c in inrecs:
            c['noordre']=noordre
            file.write(ligneaviexp % c)
            file.write('\r\n')
            noordre+=1

        file.close()

        if cde:
            # Création fichier expédition CODES Barre Cegid
            # Trier par UM, UC pour pouvoir numeroter les palettes et colis
            inrecs.sort(cmp=lambda x,y: cmp(x['um']+x['uc'], y['um']+y['uc']))
            # Verif meme cde

            # Verifier quant/article par rapport a la commande
            # Si incomplet : BL sera acompte sinon solde.

            # transformer en fichier integration CegidPMI
            if os.path.isdir('/home/exchange/'):
                if not os.path.isdir('/home/exchange/cegidpmi/expeditions/'):
                    os.makedirs('/home/exchange/cegidpmi/expeditions')
                file=open('/home/exchange/cegidpmi/expeditions/%s.txt' % (cde),'w')
            else:
                file=open('s:/%s.txt' % (cde),'w')

            print inrecs
            #outcols="%(type)s;%(cde)%(ligne)s;%(depot)s;%(lot)s;%(nocolis)s;%(qtecolis)s;%(pdsnet)s;%(pdsnet)s;%(volume)s;%(nopalette)s;%(codeembal)s;%(libembal)s;%(datecol)s;%(um)s;%(uc)s;%(noordre)i;%(pointdest)s"
            lignecegid="X;%(nocde)s%(noligne)s;;%(lot)s;%(noordre)i;%(quantcond)s;;;;;;;;%(um)s;%(uc)s;%(noordre)i;"

            noordre=1
            for c in inrecs:
                c['noordre']=noordre
                #(c['nocde'],c['noligne'])=c['cde'].split('.')
                if '.' in cde:
                    (c['nocde'],c['noligne'])=cde.split('.')
                else:
                    (c['nocde'],c['noligne'])=(cde,'010')
                file.write(lignecegid % c)
                file.write('\r\n')
                noordre+=1
            file.close()

        return "OK"

    uploadcolisage.exposed=True

    def form_eti9(self,cde='100127',ligne='010',no_debut='',no_fin=''):
        """Formuaire HTML pour la génération d'étiquettes ETI9"""
        return self.template('Edition étiquettes ETI9',
            html_form('eti9','eti9',
                html_text_edit('Commande','cde',cde)+
                html_text_edit('Ligne','ligne',ligne)+
                html_text_edit('N° début','no_debut',no_debut)+
                html_text_edit('N° fin','no_fin',no_fin)
            ))
    form_eti9.exposed=True

    def eti9(self,cde='100127',ligne='010',no_debut='',no_fin=''):
        """Création d'un PDF d'étiquettes ETI9 pour les pièces d'un OF"""
        # Recup si OF d'un article ensemble process
        ofprocess=self.select(SQL_ENS_PROCESS % {'cde':cde,'ligne':ligne}).fetchonemap()

        if ofprocess:
          # Recuperation de l'enregistrement
          ofdatas=self.select(SQL_ETI9_PROD_RESULTANT % {'cde':cde,'ligne':ligne}).fetchallmap()
        else:
          # Recuperation de l'enregistrement
          ofdatas=self.select(SQL_ETI9 % {'cde':cde,'ligne':ligne}).fetchallmap()

        if ofdatas:
            # Creation d'un fichier en memoire pour stocker le PDF temporaire
            pdf=StringIO()
            c=canvas.Canvas(pdf)

            for ofdata in ofdatas:
              #Suppression des espaces avant apres des champs
              # r est un map des champs.
              r={}
              for col in ofdata.iteritems():
                if isinstance(col[1],str):
                    r[col[0]]=col[1].strip().decode('iso8859').encode('utf8')
                else:
                    r[col[0]]=col[1]


              # Les numeros d'etiquette debut-fin sont sous la forme "5-20" dans le champs NOETI
              if (no_debut<>'') and (no_fin<>''):
                noeti_debut=int(no_debut)
                noeti_fin=int(no_fin)
              elif r['NOETI']:
                noeti_debut=int(r['NOETI'].split('-')[0])
                noeti_fin=int(r['NOETI'].split('-')[1])
              else:
                noeti_debut=0
                noeti_fin=0

              if noeti_fin-noeti_debut > 1000:
                raise Exception('Nombre etiquettes limite : 1000')
              hauteur_bande=74
              inter_bande=2
              marge=5

              y=297-marge-hauteur_bande
              noeti=noeti_debut
              empty=True

              while noeti<=noeti_fin:
                draw_eti9(c,0,y,
                    destinataire=r['CLIENT'][0:28],
                    pt_decharg=r['PT_DECHARG'],
                    pt_destination='',
                    expediteur='SERMO AIGREFEUILLE',
                    code_routage='',
                    code_produit=r['REFERENCE'] or r['CODEART'],
                    quant=r['QTECOND'],
                    ref_fournisseur=r['CDE'],
                    no_etiq=noeti,
                    poids_net=Decimal('1.0')*r['PDSBRUT']*r['QTECOND'],
                    poids_brut=Decimal('1.0')*r['PDSBRUT']*r['QTECOND'],
                    date=r['DATECREAT'][2:],
                    nb=1,
                    description=r['LIBART'],
                    no_lot=r['CDE'],
                    ind_modif=r['CCART'],
                    code_vendeur=r['CODEFOURNISSEUR']
                )
                empty=False
                # Si on n'a plus la place de placer une etiquette
                if y-inter_bande-hauteur_bande < marge:
                    c.showPage()
                    y=297-marge-hauteur_bande
                    empty=True
                else:
                    y-=hauteur_bande+inter_bande
                noeti+=1

              if not empty:
                c.showPage()
              c.save()
            # renvoie la chaine de caractere PDF
            cherrypy.response.headerMap["Content-Type"] = "application/pdf"
            cherrypy.response.headerMap["Content-Disposition"] = "attachment; filename=%s.pdf" % ("%s-%s-%s" %(get_my_name(),cde,ligne))
            cherrypy.response.headerMap["Cache-Control"] = "no-store"
            return pdf.getvalue()
        else:
            return self.template('Erreur','Pas de d\'OF trouvé')

    eti9.exposed=True

if __name__=='__main__':
    test=Colisage()
    print test.eti9()

